#ifndef GENIE_OSTREAM__
#define GENIE_OSTREAM__


// Declare an OMANIP to allow setting of text colours
	ostream& sc( ostream& os, int col );
	GENIEIMPORT OMANIP(int) setcolour( int col );


class genie_ostream : public ostream
{

private:

    int col;				// Records the text colour for the stream
    const int 	buffer_length;
    char* 	buffer;
    ostrstream  sofar;
    int         logging, screen;	// (Was defined as bool)

    // constructors

public:

// moved this up two lines from here for Linux & gcc 2.6.3
//public:
	inline genie_ostream() : buffer_length(0), buffer(0), logging(0), screen(0) { }

	// screen_output = 1    -> echo to screen 
	GENIEIMPORT genie_ostream(ostream& s, int c = 0, int screen_output = 0, int log = 0);

	// destructor
	inline ~genie_ostream() { delete buffer; }

	// return pointer to characters so far in strstream, and reset to to start
	GENIEIMPORT const char* str();

	// switch stream on or off, for no parameter, just report current setting
	GENIEIMPORT int mode( int mode = 2 ) { if (mode==2) return screen; else { screen = mode; return screen; } }

	GENIEIMPORT genie_ostream &operator=(ostream& s);
	GENIEIMPORT genie_ostream &operator=(genie_ostream& s);

    	// special flush for logging (if enabled)
    	GENIEIMPORT genie_ostream& flush();
	
	// The member we want to redefine to bracket the output
	// Note: col + 1 is the code for <colour>_OFF (see StreamColour enum in iofuncs.h)
	inline genie_ostream &operator<<(const char *a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(char a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(short a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(int a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(long a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(unsigned char a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(unsigned short a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(unsigned int a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(unsigned long a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
//#ifdef __ultrix
      inline genie_ostream &operator<<(void *a)		// prototype for "const void*" not present
//#else
//      inline genie_ostream &operator<<(const void *a)
//#endif /* __ultrix */
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(streambuf *a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(float a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(double a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }
	inline genie_ostream &operator<<(const String& a)
        { if (screen) { ostream::operator<<("") << setcolour(col) << a << setcolour(col+1); flush(); }; sofar << a; return *this; }

	// No point in bracketing the output of IO manips!
	GENIEIMPORT genie_ostream &operator<<(ostream &(*a)(ostream &));
	GENIEIMPORT genie_ostream &operator<<(ios &(*a)(ios &));
    
	// redefine write() to add start and stop sequences
	ostream& write(const char *s, size_t n)
	{
		if (screen)
		{
			setcolour(col);
			ostream::flush();
			ostream::write((const char*)s, n);
			setcolour(col+1);
			ostream::flush();
		};
		sofar.write((const char*)s, n);
		return *this;
	}

/*
   	ostream& write(const unsigned char *s, streamsize n)
      		{ return write((const char*)s, n);}
    	ostream& write(const signed char *s, streamsize n)
      		{ return write((const char*)s, n);}
    	ostream& write(const void *s, streamsize n)
      		{ return write((const char*)s, n);}
*/

};


#endif /* GENIE_OSTREAM__ */
